VERSION 5.00
Begin VB.UserControl DraggableAny 
   BackColor       =   &H8000000C&
   ClientHeight    =   1440
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1560
   ControlContainer=   -1  'True
   MousePointer    =   5  'Size
   ScaleHeight     =   1440
   ScaleWidth      =   1560
   ToolboxBitmap   =   "DragAny.ctx":0000
   Begin VB.PictureBox Corner 
      BackColor       =   &H8000000D&
      BorderStyle     =   0  'None
      Height          =   60
      Left            =   1440
      MousePointer    =   8  'Size NW SE
      ScaleHeight     =   60
      ScaleWidth      =   60
      TabIndex        =   0
      Top             =   1320
      Width           =   60
   End
End
Attribute VB_Name = "DraggableAny"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "CCC Draggable anything container control"
Option Explicit

'Default Property Values:
Const m_def_Draggable = True
Const m_def_MinWidth = 240
Const m_def_MaxWidth = 100000
Const m_def_MinHeight = 240
Const m_def_MaxHeight = 100000
Const m_def_HandleSize = 45
'Property Variables:
Dim m_Draggable As Boolean
Dim m_MinWidth As Long
Dim m_MaxWidth As Long
Dim m_MinHeight As Long
Dim m_MaxHeight As Long
Dim m_HandleSize As Long

Dim Resizing As Boolean
Dim Moving As Boolean
Dim StartX As Single
Dim StartY As Single
' *********************************************
' Show the About dialog.
' *********************************************
Public Sub ShowAbout()
Attribute ShowAbout.VB_Description = "Displays the About dialog."
Attribute ShowAbout.VB_UserMemId = -552
Dim frm As New AboutDialog

    frm.Show vbModal
    Set frm = Nothing
End Sub

' *********************************************
' Clear this control's size and position
' information from the registry. Use
' "DraggablePositions" as the section. Use the
' control's name to generate keys.
' *********************************************
Public Sub ClearPosition(AppName As String)
Attribute ClearPosition.VB_Description = "Clears stored size and position information from the registry."
Dim key As String

    ' Get the control name.
    key = Extender.Name
    On Error Resume Next
    key = key & "(" & Format$(Extender.Index) & ")"
    On Error GoTo 0
    
    DeleteSetting AppName, "DraggablePositions", _
        key & ".Left"
    DeleteSetting AppName, "DraggablePositions", _
        key & ".Top"
    DeleteSetting AppName, "DraggablePositions", _
        key & ".Width"
    DeleteSetting AppName, "DraggablePositions", _
        key & ".Height"
End Sub

' *********************************************
' Save this control's size and position
' information in the registry. Use
' "DraggablePositions" as the section. Use the
' control's name to generate keys. The items
' are always saved in pixels.
' *********************************************
Public Sub SavePosition(AppName As String)
Attribute SavePosition.VB_Description = "Makes the control save its size and position information from the registry."
Dim key As String
Dim parent_mode As Integer

    ' Get the control name.
    key = Extender.Name
    On Error Resume Next
    key = key & "(" & Format$(Extender.Index) & ")"
    On Error GoTo 0
    
    parent_mode = Extender.Parent.ScaleMode
    SaveSetting AppName, "DraggablePositions", _
        key & ".Left", _
        ScaleX(Extender.Left, parent_mode, vbPixels)
    SaveSetting AppName, "DraggablePositions", _
        key & ".Top", _
        ScaleX(Extender.Top, parent_mode, vbPixels)
    SaveSetting AppName, "DraggablePositions", _
        key & ".Width", _
        ScaleX(Extender.Width, parent_mode, vbPixels)
    SaveSetting AppName, "DraggablePositions", _
        key & ".Height", _
        ScaleX(Extender.Height, parent_mode, vbPixels)
End Sub
' *********************************************
' Load this control's size and position
' information from the registry. Use
' "DraggablePositions" as the section. Use the
' control's name to generate keys. The items
' are always saved in pixels.
' *********************************************
Public Sub LoadPosition(AppName As String)
Attribute LoadPosition.VB_Description = "Makes the control load size and position information from the registry."
Dim parent_mode As Integer
Dim key As String
Dim txt As String
Dim l As Single
Dim t As Single
Dim w As Single
Dim h As Single

    ' Get the control name.
    key = Extender.Name
    On Error Resume Next
    key = key & "(" & Format$(Extender.Index) & ")"
    On Error GoTo 0
    
    parent_mode = Extender.Parent.ScaleMode
    txt = GetSetting(AppName, _
        "DraggablePositions", _
        key & ".Left", "")
    If txt = "" Then
        l = Extender.Left
    Else
        l = ScaleX(CInt(txt), vbPixels, parent_mode)
    End If
    
    txt = GetSetting(AppName, _
        "DraggablePositions", _
        key & ".Top", "")
    If txt = "" Then
        t = Extender.Top
    Else
        t = ScaleY(CInt(txt), vbPixels, parent_mode)
    End If
    
    txt = GetSetting(AppName, _
        "DraggablePositions", _
        key & ".Width", "")
    If txt = "" Then
        w = Extender.Width
    Else
        w = ScaleX(CInt(txt), vbPixels, parent_mode)
    End If
    
    txt = GetSetting(AppName, _
        "DraggablePositions", _
        key & ".Height", "")
    If txt = "" Then
        h = Extender.Height
    Else
        h = ScaleY(CInt(txt), vbPixels, parent_mode)
    End If
    
    Extender.Move l, t, w, h
End Sub

'WARNING! DO NOT REMOVE OR MODIFY THE FOLLOWING COMMENTED LINES!
'MappingInfo=UserControl,UserControl,-1,Enabled
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
End Property
' *********************************************
' Start resizing the control.
' *********************************************
Private Sub Corner_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Draggable Then Exit Sub
    Resizing = True
    StartX = X
    StartY = Y
End Sub

' *********************************************
' Resize the control.
' *********************************************
Private Sub Corner_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim dw As Single
Dim dh As Single
Dim wid As Single
Dim hgt As Single
Dim w As Single
Dim h As Single

    ' Do nothing unless we're resizing.
    If Not Resizing Then Exit Sub
    
    dw = X - StartX
    dh = Y - StartY
    If dw = 0 And dh = 0 Then Exit Sub
    
    wid = Width + dw
    ' Make sure we will fit on the form.
    w = ScaleX(wid, ScaleMode, Parent.ScaleMode)
    If w > Parent.ScaleWidth - Extender.Left Then
        w = Parent.ScaleWidth - Extender.Left
        wid = ScaleX(w, Parent.ScaleMode, ScaleMode)
    End If
    ' Stay between MinWidth and MaxWidth.
    If wid < m_MinWidth Then wid = m_MinWidth
    If wid > m_MaxWidth Then wid = m_MaxWidth
    
    hgt = Height + dh
    ' Make sure we will fit on the form.
    h = ScaleX(hgt, ScaleMode, Parent.ScaleMode)
    If h > Parent.ScaleHeight - Extender.Top Then
        h = Parent.ScaleHeight - Extender.Top
        hgt = ScaleY(h, Parent.ScaleMode, ScaleMode)
    End If
    ' Stay between MinHeight and MaxHeight.
    If hgt < m_MinHeight Then hgt = m_MinHeight
    If hgt > m_MaxHeight Then hgt = m_MaxHeight

    Size wid, hgt
End Sub
' *********************************************
' Stop resizing the control.
' *********************************************
Private Sub Corner_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Resizing = False
End Sub

' *********************************************
' Start moving the control.
' *********************************************
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not Draggable Then Exit Sub
    Moving = True
    StartX = X
    StartY = Y
End Sub

' *********************************************
' Move the control.
' *********************************************
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim dl As Single
Dim dt As Single
Dim l As Single
Dim t As Single
Dim wid As Single
Dim hgt As Single

    ' Do nothing unless we're moving.
    If Not Moving Then Exit Sub
    
    dl = X - StartX
    dt = Y - StartY
    If dl = 0 And dt = 0 Then Exit Sub
    
    l = Extender.Left + ScaleX(dl, ScaleMode, Parent.ScaleMode)
    t = Extender.Top + ScaleY(dt, ScaleMode, Parent.ScaleMode)
    If l < 0 Then l = 0
    If t < 0 Then t = 0
    wid = ScaleX(Width, ScaleMode, Parent.ScaleMode)
    hgt = ScaleY(Height, ScaleMode, Parent.ScaleMode)
    If l > Parent.ScaleWidth - wid Then l = Parent.ScaleWidth - wid
    If t > Parent.ScaleHeight - hgt Then t = Parent.ScaleHeight - hgt

    Extender.Move l, t
End Sub
' *********************************************
' Stop moving the control.
' *********************************************
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Moving = False
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    m_HandleSize = PropBag.ReadProperty("HandleSize", m_def_HandleSize)
    m_MinWidth = PropBag.ReadProperty("MinWidth", m_def_MinWidth)
    m_MaxWidth = PropBag.ReadProperty("MaxWidth", m_def_MaxWidth)
    m_MinHeight = PropBag.ReadProperty("MinHeight", m_def_MinHeight)
    m_MaxHeight = PropBag.ReadProperty("MaxHeight", m_def_MaxHeight)
    Draggable = PropBag.ReadProperty("Draggable", m_def_Draggable)
    
    ' Move the corner control to the top.
    Corner.ZOrder
    
    UserControl_Resize
End Sub
Private Sub UserControl_Resize()
Dim hgt As Single
Dim ctl As Control

    ' Do nothing at design time.
    If Not Ambient.UserMode Then Exit Sub
    
    ' Position the corner dragger.
    hgt = ScaleHeight - m_HandleSize
    If hgt < 1 Then hgt = 1
    Corner.Move ScaleWidth - m_HandleSize, _
        hgt, m_HandleSize, m_HandleSize
    
    ' Position the contained controls.
    For Each ctl In ContainedControls
        ctl.Move 0, 0, ScaleWidth, hgt
    Next ctl
End Sub
'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("HandleSize", m_HandleSize, m_def_HandleSize)
    Call PropBag.WriteProperty("MinWidth", m_MinWidth, m_def_MinWidth)
    Call PropBag.WriteProperty("MaxWidth", m_MaxWidth, m_def_MaxWidth)
    Call PropBag.WriteProperty("MinHeight", m_MinHeight, m_def_MinHeight)
    Call PropBag.WriteProperty("MaxHeight", m_MaxHeight, m_def_MaxHeight)
    Call PropBag.WriteProperty("Draggable", m_Draggable, m_def_Draggable)
End Sub

Public Property Get HandleSize() As Long
Attribute HandleSize.VB_Description = "The size of the grab handle in pixels."
    HandleSize = ScaleX(m_HandleSize, vbTwips, vbPixels)
End Property

Public Property Let HandleSize(ByVal New_HandleSize As Long)
    If New_HandleSize < 0 Then New_HandleSize = 0
    m_HandleSize = ScaleX(New_HandleSize, vbPixels, vbTwips)
    PropertyChanged "HandleSize"
    
    UserControl_Resize  ' Rearrange.
End Property

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_HandleSize = m_def_HandleSize
    m_MinWidth = m_def_MinWidth
    m_MaxWidth = m_def_MaxWidth
    m_MinHeight = m_def_MinHeight
    m_MaxHeight = m_def_MaxHeight
    m_Draggable = m_def_Draggable
End Sub

Public Property Get MinWidth() As Long
Attribute MinWidth.VB_Description = "The minimum width the user can give the control in the parent's units."
    MinWidth = ScaleX(m_MinWidth, vbTwips, Parent.ScaleMode)
End Property

Public Property Let MinWidth(ByVal New_MinWidth As Long)
    m_MinWidth = ScaleX(New_MinWidth, Parent.ScaleMode, vbTwips)
    PropertyChanged "MinWidth"
End Property

Public Property Get MaxWidth() As Long
Attribute MaxWidth.VB_Description = "The maximum width the user can give the control in the parent's units."
    MaxWidth = ScaleX(m_MaxWidth, vbTwips, Parent.ScaleMode)
End Property

Public Property Let MaxWidth(ByVal New_MaxWidth As Long)
    m_MaxWidth = ScaleX(New_MaxWidth, Parent.ScaleMode, vbTwips)
    PropertyChanged "MaxWidth"
End Property

Public Property Get MinHeight() As Long
Attribute MinHeight.VB_Description = "The minimum height the user can give the control in the parent's units."
    MinHeight = ScaleY(m_MinHeight, vbTwips, Parent.ScaleMode)
End Property

Public Property Let MinHeight(ByVal New_MinHeight As Long)
    m_MinHeight = ScaleY(New_MinHeight, Parent.ScaleMode, vbTwips)
    PropertyChanged "MinHeight"
End Property

Public Property Get MaxHeight() As Long
Attribute MaxHeight.VB_Description = "The maximum height the user can give the control in the parent's units."
    MaxHeight = ScaleY(m_MaxHeight, vbTwips, Parent.ScaleMode)
End Property

Public Property Let MaxHeight(ByVal New_MaxHeight As Long)
    m_MaxHeight = ScaleY(New_MaxHeight, Parent.ScaleMode, vbTwips)
    PropertyChanged "MaxHeight"
End Property
Public Property Get Draggable() As Boolean
Attribute Draggable.VB_Description = "Indicates the user can drag the control."
    Draggable = m_Draggable
End Property

Public Property Let Draggable(ByVal New_Draggable As Boolean)
    m_Draggable = New_Draggable

    If m_Draggable Then
        Corner.Visible = True
        UserControl.MousePointer = vbSizeAll
        UserControl.BackColor = &H8000000C
    Else
        Corner.Visible = False
        UserControl.MousePointer = vbArrow
        UserControl.BackColor = Parent.BackColor
    End If

    PropertyChanged "Draggable"
End Property
